BEGIN { ectdebug = ENVIRON["ECTDEBUG"] ~ "[-Yy1-9]" }
(ectdebug != 0) {print NR":	"$0}
{if ($0 ~ "^[[:print:]]*[([[:print:]]*$")
  {
    ADDROUT=ENVIRON["DB"]"/addr2line.out"
    SIZEOUT=ENVIRON["DB"]"/print_sizeof.gdbout"
    split($0,a,"(")
    SaveString=$0
    $0=a[1]
    sub("^[*]*","",$NF)
    StringOut[0] = $NF
    $0=SaveString
    if (index($0,"(") == 0 && match($0,",") == 0)
    {
      next 
    }
    if (length(ENVIRON["DB"])==0)
    {
       ENVIRON["DB"]="."
    }
    while ($1 == "" || $1 == "
")
    {
      getline
    }

    if ($1 == "static")
    {
      StringOut[4] = "static"
    }
    else
    {
      StringOut[4] = "global"
    }
    i = 0 
    j = 0
    line = 0
    while( (match($(i),"[(]") == 0 && match($(i),",") == 0)) 
    {
      if (i == NF)
      {
        SaveS[line]=$0
        getline
        line++
        i=0
        continue
      }
     i++
    }
    FunStart=$0
    split($(i),a,"(")
    j=0
    if(a[1] == "")
    {
      while(index(SaveS[line-1]," "))
      {
        j++
      }
      if (j == 0)
      {
        StrLen=length(SaveS[line-2])
        Sindex=index(SaveS[line-2]," ")
        GetType(SaveS[line-2])
       }
    }
    else
    {
     split(a[1],b," ")
     if(b[2] == "")
     { 
       GetType(SaveS[line-1])
     }
     else
     {
       if(match(b[2],"*"))
       {
         TmpString = a[1]
         Sindex=index(a[1],"* ")
         a[1] = TmpString
         b[1]=substr(a[1],0,Sindex)
       }
       GetType(b[1])
     }
    }
    $0=FunStart
    lcount++
    VaArgs=0
    CountArgs($0,lcount) 
    StringOut[3]=StringOut[2]
    StringOut[7]="<NULL>"
    getline
    if ($0 !~ "^Line [[:print:]]* starts at address")
    {
      StringOut[5]="<NULL>"
      StringOut[6]="<NULL>"
    }
    else
    {
      command="gaddr2line "$8" -e "ENVIRON["EXEFILE"] ">> "ENVIRON["DB"]"/addr2line.out"
      system(command)
      getline < ADDROUT 
      
      split($0,b,":")
      if (b[1] == "")
      {
         StringOut[5]="<NULL>"
      }
      else
      {
         StringOut[5]=b[1]
      }
      if (b[2] == "")
      {
         StringOut[6]="<NULL>"
      }
      else
      {
         StringOut[6]=b[2]
      }
    }


    PrintString(StringOut,ENVIRON["DB"]"/tFunctionDef.tbl")

   } 
}

function CountArgs(String,linecount)
{
   sub(")[[:blank:]]*const[[:blank:]]*;[[:blank:]]*$", ");", String)
   TmpString=String
   TmpString2=String
   Args=0
   if(match(String,"{") != 0)
   {
     while(x=index(TmpString,","))
     {
       String=substr(TmpString,x+1)
       Strlen=length(TmpString)
       str=substr(TmpString2,0,x-1)
       TmpString2=TmpString 
       Args++
       GetParmType(str,linecount,Args)
       TmpString=String
       TmpString2=String
     }
       if(index(TmpString2,"([  ]*)") == 0 && index(TmpString2,"()") == 0 && match(TmpString2,"([  ]*void[  ]*)") == 0 )
       {
         Args++
         GetParmType(TmpString2,linecount,Args)
       }
   }
   else
   {
     while(match(String,";") == 0)
     {
      Strlen=length(String)
      while(x=index(String,","))
          {
            TmpString2=String
            String=substr(String,x+1) 
            Strlen=length(String)
            str=substr(TmpString2,0,x-1)
            TmpString2=String
            Args++
            GetParmType(str,linecount,Args)
          }
       
       String=$0
       Strlen=length(TmpString2)
       
       if(index(TmpString2,")") && (index(TmpString2,"([  ]*)") == 0) && (index(TmpString2,"()") == 0) && match(TmpString2,"([  ]*void[  ]*)") == 0)
       {
         Args++
         GetParmType(TmpString2,linecount,Args)
       }
       else
       {
           Args=0
       }
       if(match(String,"[  ]*[0-9,a-f]*:	"))
       {
          break
       }
       S_String=String
       if(index(String,")") && (match(String,"^[  	]*)") == 0 && index(String,",") == 0 ) ||
          (index(String,",") == 0 && index(String,")") == 0 && index(String,"{") == 0 &&
          (index(String,"([  ]*)") == 0)))
       {
         Args++
         GetParmType(String,linecount,Args)
       }
       if(Strlen > 0 && Args > 1 && index(TmpString2,")") == 0 )
       {
          Args++
             GetParmType(TmpString2,linecount,Args)
       }
      }

     tmp = String
     do {
	sub("[(][^(]*$", "", tmp)
	lpar = split(tmp, junk, "(")
	rpar = split(tmp, junk, ")")
     } while (lpar != rpar)
     ArgStr = substr(String, length(tmp) + 1)
     sub("^[^(]*[(]", "", ArgStr)
     sub("[)][^)]*$", "", ArgStr)
     String = ArgStr
     while(index(String,","))
     {
      Args++
      n = split(String, parts, ",")
      i = 0
      while (i < n) {
	i++
	if (i > 1) {
	    Arg = Arg "," parts[i]
	} else {
	    Arg = parts[i]
	}
	leftpcnt = split(Arg, junk, "[(]")
	rightpcnt = split(Arg, junk, "[)]")
	ltcnt = split(Arg, junk, "[<]")
	gtcnt = split(Arg, junk, "[>]")
	if ((leftpcnt == rightpcnt) && (ltcnt == gtcnt))
	    break;
      }
      GetParmType(Arg,linecount,Args)
      String=substr(String,length(Arg)+1)
      sub("^, *", "", String)
     }
     if ((String !~ /^[[:blank:]]*$/) &&
	 (String != "void") &&
	 (String !~ /^[[:blank:]]*([[:blank:]]*)[[:blank:]]*$/) &&
	 (String !~ /^[[:blank:]]*[(][[:blank:]*void[[:blank:]*)[[:blank:]]/))
     {
       Args++
       GetParmType(String,linecount,Args)
     }
   }

   if(VaArgs)
   {
     Args--
   }
   StringOut[2]=Args 
}
     
function GetTypeDef(ParmString,Args)
{
  if(Args == 1)
  {
    split(ParmString,z,"(")
    ParmString=z[2]
  }
     
  if(match(substr(ParmString,0,4),"char ") 	||
     match(substr(ParmString,0,4),"char*") 	||
     match(substr(ParmString,0,4),"char,") 	||
     match(substr(ParmString,0,3),"int ") 	||
     match(substr(ParmString,0,3),"int*") 	||
     match(substr(ParmString,0,3),"int,") 	||
     match(substr(ParmString,0,4),"long ") 	||
     match(substr(ParmString,0,4),"long*") 	||
     match(substr(ParmString,0,4),"long,") 	||
     match(substr(ParmString,0,5),"short ") 	||
     match(substr(ParmString,0,5),"short*") 	||
     match(substr(ParmString,0,5),"short,") 	||
     match(substr(ParmString,0,5),"float ") 	||
     match(substr(ParmString,0,5),"float*") 	||
     match(substr(ParmString,0,5),"float,") 	||
     match(substr(ParmString,0,6),"double ") 	||
     match(substr(ParmString,0,6),"double*") 	||
     match(substr(ParmString,0,6),"double,") 	||
     match(substr(ParmString,0,8),"unsigned ") 	||
     match(substr(ParmString,0,4),"void ")	||
     match(substr(ParmString,0,4),"void*") 	||
     match(substr(ParmString,0,4),"void,")  	||
     match(substr(ParmString,0,4),"void)")      ||
     match(substr(ParmString,0,4),"FILE*")      || 
     match(substr(ParmString,0,4),"FILE ")) 
     {
        StringOut2[3]=0
     }
     else
     {
        StringOut2[3]=1
     }
}

function GetStructureFlag(ParmString)
{
   if(match(substr(ParmString,0,8),"stucture "))
   {
    StringOut2[4]=1
   }
   else
   {
     StringOut2[4]=0
   }
}
   
function GetGdbSize(Ftype)
{
    command="echo \"print sizeof("Ftype")\" > $DB/gdbcommands3.txt"
    system(command) 
    command="gdb --readnow --batch --command=$DB/gdbcommands3.txt "ENVIRON["EXEFILE"] ">> "SIZEOUT
    rc = system(command)
    getline < SIZEOUT
    if ($0 !~ /^[[:print:]]*= /)
	getline < SIZEOUT
    sub("^[[:print:]]*= ","",$0)
    DataSize=$0
}

function GetParmType(ParmString,linecount,Args)
{
  ParmNo = Args
  sub(");[[:blank:]]*$","",ParmString)
  if (ci=index(ParmString,"{"))
  {
    ParmString=substr(ParmString,0,ci-1)
  }
  if (index(ParmString,"..."))
  {
    VaArgs=1
    return
  }
  GetTypeDef(ParmString,Args)
  GetStructureFlag(ParmString)
  Reference=0
  FunctionKey=linecount
  if (ParmString ~ "[*]" || ParmString ~ "[[][  ,[:print:]]*[]]")
  {
     Bytes=4
    
     sub("^ *", "", ParmString)
     TmpString=ParmString
     sub("[ *]*$", "", ParmString)
     TmpString = substr(TmpString, length(ParmString))
     DReferences=gsub("[*]","*",TmpString)
     TmpString=ParmString
     if(match(TmpString,"[[:blank:]]*[(][[:print:]]*$") != 0)
     {
       sub("[[:blank:]]*[(][[:print:]]*$","",TmpString) 
     } 
     if (ParmString ~ "[[][  ,[:print:]]*[]]")
     {
        DReferences++ 
        sub(" [[:print:]]* *[[[:print:]]*]"," []",ParmString)
        TmpString=ParmString
     }
     DataSize=Bytes
     ASize=DataSize
     n = split(TmpString, a, ",")
     for (i in a) {
	if (a[i] ~ /const *[*&] *$/) {
	    sub("const", "", a[i])
	    if (i == 1) {
		n = match(a[i], "[[:punct:]]")
		a[i] = substr(a[i], 1, n) " const " substr(a[i], n + 1)
	    } else {
		a[i] = "const " a[i]
	    }
	}
	if (i == 1) {
	    TmpString = a[i]
	} else {
	    TmpString = TmpString "," a[i]
	}
     }
     GetSize(TmpString)
     RSize=DataSize
     gsub("^[ 	]*","",TmpString)
     gsub("[ 	]*$","",TmpString)
     gsub("[	]*","",TmpString)
     sub("*"," *",TmpString)
     ParmType=TmpString   
     Reference=DReferences
     DataSize=ASize
  }
  else
  {
    TmpString=ParmString
    sub("^ *", "", TmpString)
    LastIndex=0 
    IndexString=TmpString
    while(x=index(IndexString," "))
    {
     LastIndex=LastIndex+x
     IndexString=substr(TmpString,LastIndex+1)
    }
    while(x=index(IndexString,"\t"))
    {
     LastIndex=LastIndex+x
     IndexString=substr(TmpString,LastIndex+1)
    }
    Reference=0
    ParmType=TmpString
    GetSize(TmpString)
    RSize=DataSize
  }
  StringOut2[0]=FunctionKey
  StringOut2[1]=ParmNo
  StringOut2[2]=ParmType
  StringOut2[5]=Reference
  StringOut2[7]=DataSize
  StringOut2[6]=RSize
  if (length(ENVIRON["DB"])==0)
  {
       ENVIRON["DB"]="."
  }
  PrintString(StringOut2,ENVIRON["DB"]"/tFunctionDefParms.tbl")
}

function GetSize(Ptype)
{
     i=0
     SIZTBL=ENVIRON["DB"]"/sizes.tbl"
     SaveFS=FS
     FS="\t"
     gsub("^[ 	]*","",Ptype)
     gsub("[ 	]*$","",Ptype)
     while(match(substr(Ptype,length(Ptype))," ") || match(substr(Ptype,length(Ptype)),"	"))
     {
       Ptype=substr(Ptype,0,length(Ptype)-1)
     }
     firstchar=substr(Ptype,0,1)
     while(match(firstchar,"	") != 0 || match(firstchar," ") != 0 )
     {
       Ptype=substr(Ptype,2)
       firstchar=substr(Ptype,0,1)
     }

     while((getline < SIZTBL ) > 0)
     {
        TypeName[i]=$1
        TypeSize[i]=$2
        i++
     }
     i=0
     Bytes=0
     if (substr(Ptype,length(Ptype),1)=="*" || substr(Ptype,length(Ptype),1)==" " || substr(Ptype,length(Ptype),1)=="]")
     {
       while (substr(Ptype,length(Ptype),1)=="*" || substr(Ptype,length(Ptype),1)==" " || substr(Ptype,length(Ptype),1)=="]" || substr(Ptype,length(Ptype),1)=="[" || substr(Ptype,length(Ptype),1)=="	")
       {
          Ptype=substr(Ptype,0,length(Ptype)-1)
       }
     }
     sub("^struct *","",Ptype)
     sub("^std::","",Ptype)
     for(i in TypeName)
     {
       if(Ptype==TypeName[i])
       {
        Bytes=TypeSize[i]
        break
       }
     }
      ParmType=Ptype
      DataSize=Bytes
      if (DataSize <= 0)
      {
       GetGdbSize(Ptype)
      } 
      FS=SaveFS
}
   
function PrintString(String,table)
{
    i = 0
    while ( i in String && (i+1) in String)
    {
      printf "%s\t",String[i] >> table 
      String[i]=""
      i++
    }
    printf "%s\n",String[i] >> table 
    String[i]=""
}
 
function GetType(String)
{

   StrLen=length(String)

   if (String == "" || String == "
")
   {
    StringOut[1]="<NULL>"
    return
   }

   $0=String
   TmpString=String
   while(String=substr(String,x=index(String," ")+1,StrLen-x+1))
   {
     StrLen=length(String)
     if(x == 1)
     {
        break
     }
     j++
    }
    if(j==0) 
    {
     String=TmpString
     if(split(TmpString,b,"*") != 0)
     {
       if(b[1] == "")
       {
           StringOut[1]=$(NF-j) String
       }
       else
       {
          StringOut[1]=String
       }
     }
     else
     {
        StringOut[1]=String
     }
    }
    else
    {
        String = TmpString
        if((y = split(String,b,"*")) > 1 )
        {
          if(b[1] == "")
          {
             StringOut[1]=$(NF-j) String
          }
          else
          {
             StringOut[1]=String
          }

        }
        else
        {
          StringOut[1]=$(NF)
        }
     }
}
