#!/bin/bash 
#
# Linux Compatablity Tool ioctl Call Checker
#
if [[ -z $DB ]]
then
    echo "Missing assignment"
    echo "    DB environment variable not set"
    exit 1
fi

cat ${ECTBIN}/ioctlchecklist.txt  | while read APICALL
do
   ggrep "${APICALL}" ${DB}/tFunctionRef.tbl | \
                gawk '{print $3 "\t" $4 "\tW10001\tPotentially harmful use of ioctl: " $7 }' >> ${DB}/tSourceMsgs.tbl
done
exit 0
