#!/bin/bash 
#
# Linux Compatablity Tool Source Editor
#

if [[ -z "$1" ]]
then
    echo "--- Missing argument #1: Filename ---"
    echo "    Usage is $0 <Filename> <Line number>"
    sleep 3
    exit 1
fi

if [[ -z "$2" ]]
then
    echo "--- Missing argument #2: Line number ---"
    echo "    Usage is $0 <Filename> <Line number>"
    sleep 3
    exit 1
fi

if [[ ! -r "$1" ]]
then
    echo "--- No permission to read $1 ---"
    sleep 3
    exit 1
fi

# This is where you may make changes by invoking the editor of your choice
xterm -l -e vi $1 +$2 &
exit 0
